/**
 * @file
 *
 * @ingroup demo
 *
 * @brief USB system initialization.
 */

/*
 * Copyright (c) 2009, 2010 embedded brains GmbH.  All rights reserved.
 *
 *  embedded brains GmbH
 *  Obere Lagerstr. 30
 *  82178 Puchheim
 *  Germany
 *  <rtems@embedded-brains.de>
 *
 * The license and distribution terms for this file may be
 * found in the file LICENSE in this distribution or at
 * http://www.rtems.com/license/LICENSE.
 */

#include <rtems/freebsd/machine/rtems-bsd-sysinit.h>

#include <bsp.h>

#ifdef USB_SYSINIT_INIT

struct sysinit *_bsd_sysinit_table [] = {
	SYSINIT_DRIVER_ENTRY(nexus, root),
        #if defined(LIBBSP_ARM_LPC24XX_BSP_H) || defined(LIBBSP_ARM_LPC32XX_BSP_H)
	        SYSINIT_DRIVER_ENTRY(ohci, nexus),
        #elif defined(__GEN83xx_BSP_h)
	        SYSINIT_DRIVER_ENTRY(ehci, nexus),
        #endif
	SYSINIT_DRIVER_ENTRY(uhub, uhub),
	SYSINIT_DRIVER_ENTRY(uhub, usbus),
	SYSINIT_DRIVER_ENTRY(umass, uhub),
	SYSINIT_DRIVER_ENTRY(ums, uhub),
	SYSINIT_DRIVER_ENTRY(usbus, at91_udp),
	SYSINIT_DRIVER_ENTRY(usbus, ehci),
	SYSINIT_DRIVER_ENTRY(usbus, ohci),
	SYSINIT_DRIVER_ENTRY(usbus, uhci),
	SYSINIT_DRIVER_ENTRY(usbus, uss820),
	SYSINIT_ENTRY(configure1),
	SYSINIT_ENTRY(configure2),
	SYSINIT_ENTRY(configure3),
	SYSINIT_ENTRY(kobj),
	SYSINIT_ENTRY(linker_kernel),
	SYSINIT_ENTRY(module),
	SYSINIT_ENTRY(usb_quirk_init),
	SYSINIT_MALLOC_ENTRY(M_BUS),
	SYSINIT_MALLOC_ENTRY(M_BUS_SC),
	SYSINIT_MALLOC_ENTRY(M_DEVBUF),
	SYSINIT_MALLOC_ENTRY(M_KOBJ),
	SYSINIT_MALLOC_ENTRY(M_MODULE),
	SYSINIT_MALLOC_ENTRY(M_TEMP),
	SYSINIT_MALLOC_ENTRY(M_USB),
	SYSINIT_MALLOC_ENTRY(M_USBDEV),
	SYSINIT_MALLOC_ENTRY(M_USBHC),
	SYSINIT_MODULE_ENTRY(rootbus),
	NULL
};

const char *_bsd_nexus_devices [] = {
        #if defined(LIBBSP_ARM_LPC24XX_BSP_H) || defined(LIBBSP_ARM_LPC32XX_BSP_H)
                "ohci",
        #elif defined(__GEN83xx_BSP_h)
                "ehci",
        #endif
        NULL
};

#endif /* USB_SYSINIT_INIT */
